/* Created on 27-set-2005 */
package jtransfer;

import jtransfer.gui.JFileTransfer;

public class JTransfer {

	private Service service;
	
	private Thread runningThread;
	
	public JTransfer() {
		this.service = null;
		this.runningThread = null;
	}
	
	public void sendFile(String path, int port) {
		SendFile sf = new SendFile();
		this.service = (Service) sf;
		sf.setFile(path);
		sf.setPortToListenTo(port);
		this.runningThread = new Thread(sf);
		
	}
	
	public void receiveFile(String dirToSave, String ip, int port) {
		ReceiveFile rf = new ReceiveFile();
		this.service = (Service) rf;
		rf.setPathToSaveTo(dirToSave);
		rf.setIpToConnect(ip);
		rf.setPortToConnect(port);
		this.runningThread = new Thread(rf);
		
	}
	
	public static void main(String[] args) {
		JTransfer jts = new JTransfer();
		String mode = args[0];
		if (mode.equals("send")) {
			String port = args[1];
			String path = args[2];
			jts.sendFile(path,Integer.parseInt(port));
		} else if (mode.equals("receive")) {
			String port = args[1];
			String path = args[2];
			String ip = args[3];
			jts.receiveFile(path,ip,Integer.parseInt(port));
		} else {
			System.out.println("Error.. Usage: javac ...");
		}
	}

	public void addObserver(Osservatore o) {
			this.service.addObserver(o);
	}
	
	public void stop() {
		this.service.stopRunning();
		if (this.runningThread.isAlive())
			this.runningThread.stop();
	}
	
	public void startAction() {
		this.runningThread.start();
	}
}
